1000 REMark EDT_CONFIG - Screen Text editor configurator - version 2.10
1010 REMark          Jun 86,  Chas. Dillon
1020 :
1030 DATA_AREA       4
1040 :
1050 REMark extra commands/functions : DEVICE_STATUS
1060 REMark                            POSITION, SET_POSITION, ALLOCATION
1070 REMark                            CURSOR_OFF, CURSOR_ON
1080 REMark                            PEEK$, POKE$, TYPE_IN, COMMAND_LINE
1090 :
1100 IMPLICIT% ii, key
1110 :
1120 DIM vers$(6) : vers$ = '2.10'
1130 IF COMPILED : OPEN #1,'con'
1140 :
1150 Initialise
1160 REPeat retry_lp
1170   wrong% = FALSE%
1180   Set_up_Parameters
1190   IF wrong% : EXIT retry_lp
1200   Re_Write_Program
1210   IF NOT wrong% : EXIT retry_lp
1220   IF wrong% = err_cab% : EXIT retry_lp
1230   END REPeat retry_lp
1240 Shutdown
1250 STOP
1260 :
1270 DEFine PROCedure Initialise
1280   basic_data_space = 9.5   : REMark Usual data space for EDITOR
1290   array_base%  = 1         : REMark lowest subscript on char arrays
1300   max_deep%    = 255       : REMark Max no of vert. pixels
1310   min_depth%   = 4         : REMark least number of screen lines
1320   max_wide%    = 510       : REMark Max no of horiz pixels
1330   min_width%   = 20        : REMark least no. of screen cols
1340   chi_pix%     = 10        : REMark no. of vert. pixels per char
1350   cwd_pix%     = 6         : REMark no. of horiz. pixels per char
1360   search_max%  = 3         : REMark max no of compound search strings
1370 :
1380   length_of_paras = 350    : REMark Amount of configurable stuff
1390 :
1400   REMark ______________  Global string constants ___________________
1410   DIM word_delim$(30), word_markers$(30), help_name$(10)
1420   DIM prog_name$(20)
1430 :
1440   REMark ______________  Global string variables ___________________
1450   DIM key_bffr$(80)
1460   DIM yn$(2), device$(6), file_name$(50), ip_str$(200)
1470   DIM wrk$(60), dvc$(6), dflt_dvc$(6), boot_name$(20)
1480 :
1490   REMark ______________  Supercharge req'mts ___________________
1500   DIM msg$(2), str$(2), dflt$(2)
1510 :
1520   key_bffr$ = ""   : ip_str$ = ""
1530   prog_name$ = "edt_bin"
1540   REMark  ____________  Figurative constants  _________________________
1550 :
1560   TRUE%       = 1     : FALSE%     = 0
1570   ENTER%      =  10
1580   ESC%        =  27
1590   SPACE_shift%= 252
1600   lf_arrow%   = 192  : rt_arrow%   = 200
1610   lf_alt%     = 193  : rt_alt%     = 201
1620   up_arrow%   = 208  : dn_arrow%   = 216
1630   scroll_up%  = 209  : scroll_dn%  = 217
1640   del_lf%     = 194  : del_rt%     = 202
1650   del_stol%   = 195  : del_ndol%   = 203
1660 :
1670   err_syn% = 1
1680   err_cab% = 2
1690   err_nex% = 5
1700   err_tex% = 6
1710   err_ltl% = 7
1720   err_oom% = 9
1730   err_fnf% = 12
1740   err_cof% = 13
1750   err_ntb% = 17
1760   err_nts% = 18
1770   err_msp% = 19
1780   err_bfn% = 20
1790   err_nef% = 21
1800   err_oor% = 22
1810 :
1820   REMark  ------  Program control variables  ---------------------------
1830 :
1840   wrong% = FALSE%
1850   lin% = 0           :  col% = 0
1860 :
1870   REMark  -------------------------------------------------------------
1880   Announce
1890   hz_pixels% = 480 : vt_pixels% = 240 : hz_off% = 20 : vt_off% = 10
1900   depth% = 24 : width% = 80 : max_ch% = 40
1910   Show_Banner
1920   Get_IP_File
1930   END DEFine 
1940 :
1950 DEFine PROCedure Show_Banner
1960   WINDOW 512,256,0,0 : PAPER 0 : CLS
1970   Reset_Main_Window
1980   PAPER 2 : INK 0
1990   PRINT "    EDITOR Configurator - version ";vers$;"         - Chas Dillon  1986/7";
2000   CLS 4 : PAPER 0 : INK 4
2010   END DEFine 
2020 :
2030 DEFine PROCedure Set_up_Parameters
2040   Unload_Parameters
2050   AT 4,0 : PAPER 0 : INK 4 : CLS 2
2060   old_mode% = scr_mode%
2070   scr_mode% = Specified_Number%(7,(scr_mode%),"Enter the run-time screen mode (4 or 8): ",4,8,1)
2080   IF scr_mode% = 4
2090     wd_pix% = 6 : ELSE 
2100     wd_pix% = 12
2110     IF old_mode% <> scr_mode% : scr_width% = scr_width% DIV 2
2120     END IF 
2130   REPeat par_lp
2140     insert_mode% = Specified_Number%(9,(insert_mode%),"Enter the data entry mode (0,1 = Over,Insert): ",0,1,1)
2150     scr_pan% = Specified_Number%(11,(scr_pan%),"Enter the horiz. pan percentage (10 to 90): ",10,90,0)
2160     cursor_delay% = Specified_Number%(12,(cursor_delay%),"Enter the cursor speed (1 to 3000; 1=fast): ",1,3000,0)
2170     block_type% = Specified_Number%(14,(block_type%),"Enter the block type (1=Char,2=Col,3=Line): ",1,3,0)
2180     block_show% = Specified_Number%(15,(block_show%),"Enter the block visibility (0=Hide;1=Show): ",0,1,1)
2190     lin% = 22 : yn$ = Text_Response$("y","                   Confirm these are OK (n/y): ")
2200     IF yn$ == "y" : EXIT par_lp
2210     END REPeat par_lp
2220   AT 1,0 : PAPER 0 : INK 4 : CLS 2
2230   Specify_Colours
2240   REPeat par_lp
2250     AT 1,0 : PAPER 0 : INK 2 : CLS 2
2260     PRINT \"The following values SIGNIFICANTLY affect program operation - ALTER WITH CARE" : INK 4
2270     char_max%     = Specified_Number%(4,(char_max%),"Enter the maximum line length: ",20,1000,0)
2280     data_max%     = Max_Short%(256, char_max%)
2290     tab_stop%     = Specified_Number%(5,(tab_stop%),"Enter the tabbing interval: ",1,(char_max%-1),0)
2300     right_margin% = Specified_Number%(6,(right_margin%),"Enter the column of the right hand margin: ",1,(char_max%),0)
2310     wd_pix%       = Specified_Number%(8,(wd_pix%),"Enter the character width in pixels: ",6,12,0)
2320     hi_pix%       = Specified_Number%(9,(hi_pix%),"Enter the character height in pixels: ",8,10,0)
2330     search_max%   = Specified_Number%(11,(search_max%),"Enter the max no of concurrent search strings: ",1,6,0)
2340     str_max%      = Specified_Number%(12,(str_max%),"Enter the max length of a search string: ",40,256,0)
2350     file_name$    = Specified_String$(14,(file_name$),"Enter the name of the character set file: ",1,12)
2360     help_name$    = Specified_String$(15,(help_name$),"Enter the name of the help file: ",1,12)
2370     boot_name$    = Specified_String$(16,(boot_name$),"Enter the name of the boot command file: ",1,12)
2380     device$ = Specified_Device$(17,(device$),"Enter the device which will hold these files: ")
2390     dflt_dvc$ = Specified_Device$(18,(dflt_dvc$),"Enter the run-time default data device: ")
2400     word_delim$   = Specified_String$(20,(word_delim$),"Enter the word delimiters for cursor movement: ",1,30)
2410     word_markers$ = Specified_String$(21,(word_markers$),"Enter the word delimiters for string search: ",1,30)
2420     lin% = 23 : yn$ = Text_Response$("y","                   Confirm these are OK (n/y): ")
2430     IF yn$ == "y" : EXIT par_lp
2440     END REPeat par_lp
2450   AT 1,0 : PAPER 0 : INK 4 : CLS 2
2460   PRINT \\\\"    The following screen allows the sizing and positioning"
2470   PRINT    \"         of the screen area to be used by EDITOR - "
2480   PRINT \\\\"    The selection now is the default - it may be altered at run time"
2490   PRINT \\\\"    Press ENTER to continue " : IF LEN(INKEY$(#1,-1)) : END IF 
2500   Adjust_Screen
2510   Set_Screen_Format
2520   Load_Parameters
2530   END DEFine 
2540 :
2550 DEFine PROCedure Get_IP_File
2560   dvc$ = "flp2_"
2570   REPeat val_lp
2580     lin% = 4
2590     dvc$ = Text_Response$((dvc$), "Enter the name of the device which now holds 'edt_bin': ")
2600     IF LEN(dvc$) <> 5
2610       wrong% = err_syn% : ELSE 
2620       IF dvc$(5) <> "_"
2630         wrong% = err_syn% : ELSE 
2640         wrong% = File_not_Available% (3, (dvc$ & prog_name$), 0, 0)
2650         IF wrong% = 0 : EXIT val_lp
2660         END IF : END IF 
2670     Display_Error
2680     END REPeat val_lp
2690   Clear_Error
2700   file_len = Input_Length(3)
2710   bffr_addr  = RESPR((length_of_paras+100))
2720   Get_Data_Point
2730   IF wrong% : Display_Error
2740   END DEFine 
2750 :
2760 DEFine PROCedure Get_Data_Point
2770 LOCal x$(8), z, ii, located, skipper
2780   SET_POSITION #3,13500 : located = 0 : skipper = 0
2790   REPeat find_banner
2800     IF EOF(#3) : wrong% = err_nef% : EXIT find_banner
2810     IF NOT skipper : x$ = INKEY$(#3,-1)
2820     skipper = 0
2830     IF x$ <> "$" : NEXT find_banner
2840     x$ = INKEY$(#3,-1) : IF x$ <> "^" : skipper = 1 : NEXT find_banner
2850     x$ = INKEY$(#3,-1) : IF x$ <> "$" : NEXT find_banner
2860     located = POSITION(#3) : x$ = ""
2870     ii = 0 : REPeat i_lp
2880       ii = ii + 1 : IF ii > 7 : EXIT i_lp
2890       x$ = x$ & INKEY$(#3,-1) : END REPeat i_lp
2900     IF x$ = "config " : EXIT find_banner
2910     SET_POSITION #3,(located)
2920     END REPeat find_banner
2930   IF wrong% : CLOSE #3 : RETurn 
2940   z = bffr_addr-1 : skipper = bffr_addr + length_of_paras
2950   REPeat i_lp
2960     z = z + 1 : IF z > skipper : EXIT i_lp
2970     POKE z,CODE(INKEY$(#3,-1)) : END REPeat i_lp
2980   CLOSE #3
2990   data_point = located+7
3000   para_base = bffr_addr
3010   END DEFine 
3020 :
3030 DEFine PROCedure Specify_Colours
3040   PRINT \\"Define screen colours:"
3050   PRINT \"                       0 = Black  2 = Red  4 = Green  7 = White "
3060   PRINT \"Current values are displayed in the following messages"
3070   PRINT
3080   REPeat val_lp
3090     AT 8,0 : PAPER 0 : INK 4 : CLS 2 : CLS 3
3100     Get_Colours "   Main screen",(paper1_colr%),(ink1_colr%)
3110     paper1_colr% = papcol% : ink1_colr% = inkcol%
3120     Get_Colours "Command screen",(paper2_colr%),(ink2_colr%)
3130     paper2_colr% = papcol% : ink2_colr% = inkcol%
3140     Get_Colours "  Error screen",(paper3_colr%),(ink3_colr%)
3150     paper3_colr% = papcol% : ink3_colr% = inkcol%
3160     PAPER paper1_colr% : INK ink1_colr%
3170     PRINT \\\"     Main screen     ";
3180     PAPER paper2_colr% : INK ink2_colr%
3190     PRINT    "   Command screen    ";
3200     PAPER paper3_colr% : INK ink3_colr%
3210     PRINT    "    Error screen     ";
3220     lin% = 16 : yn$ = Text_Response$("y","         Confirm these are OK (y/n): ")
3230     IF yn$ == "y" : EXIT val_lp
3240     END REPeat val_lp
3250   END DEFine 
3260 :
3270 DEFine FuNction Specified_Number%(lin%, dflt%, msg$, low%, high%, equal)
3280 LOCal wk%, wrk$(60), ii
3290   REPeat val_lp
3300     wrk$ = Text_Response$((dflt%),FILL$(" ",47-LEN(msg$))&msg$)
3310     IF LEN(wrk$)
3320       wk% = 0 : ii = 0
3330       REPeat i_lp
3340         ii = ii+1 : IF ii > LEN(wrk$) : EXIT i_lp
3350         IF (wrk$(ii) INSTR "0123456789") = 0 : wk% = 1 : EXIT i_lp
3360         END REPeat i_lp
3370       IF wk% = 0
3380         wk% = wrk$
3390         IF equal
3400           IF wk% = low% : EXIT val_lp
3410           IF wk% = high% : EXIT val_lp
3420           wrong% = err_oor%
3430           ELSE 
3440           IF wk% < low%
3450             wrong% = err_nts% : ELSE 
3460             IF wk% <= high%
3470               EXIT val_lp : ELSE 
3480               wrong% = err_ntb% : END IF : END IF : END IF 
3490         ELSE : wrong% = err_nex% : END IF 
3500       ELSE : wrong% = err_nex% : END IF 
3510     Display_Error
3520     END REPeat val_lp
3530   Clear_Error
3540   RETurn wk%
3550   END DEFine 
3560 :
3570 DEFine FuNction Specified_String$(lin%, dflt$, msg$, low%, high%)
3580 LOCal wrk$(60)
3590   REPeat val_lp
3600     wrk$ = Text_Response$((dflt$),FILL$(" ",47-LEN(msg$))&msg$)
3610     IF LEN(wrk$) >= low% AND LEN(wrk$) <= high% AND wrk$<>FILL$(" ",LEN(wrk$)) : EXIT val_lp
3620     IF LEN(wrk$) : wrong% = err_ltl% : ELSE : wrong% = err_tex%
3630     Display_Error
3640     AT lin%+1,0 : PAPER 0 : CLS 4
3650     END REPeat val_lp
3660   Clear_Error
3670   RETurn wrk$
3680   END DEFine 
3690 :
3700 DEFine FuNction Specified_Device$(lin%,dflt$,msg$)
3710   REPeat val_lp
3720     wrk$ = Text_Response$((dflt$),FILL$(" ",47-LEN(msg$))&msg$)
3730     IF LEN(wrk$) = 5
3740       IF wrk$(5) = "_" AND wrk$(4) > "0" AND wrk$(4) < "9" : EXIT val_lp
3750       END IF 
3760     wrong% = err_syn%
3770     Display_Error
3780     END REPeat val_lp
3790   Clear_Error
3800   RETurn wrk$
3810   END DEFine 
3820 :
3830 DEFine PROCedure Unload_Parameters
3840   char_max%     = Up_Para%(0)
3850   orig_char_max%= Max_Short%(256, char_max%)
3860   scr_depth%    = Up_Para%(2)
3870   scr_width%    = Up_Para%(4)
3880   scr_vt_off%   = Up_Para%(6)
3890   scr_hz_off%   = Up_Para%(8)
3900   paper1_colr%  = Up_Para%(10)
3910   paper2_colr%  = Up_Para%(12)
3920   paper3_colr%  = Up_Para%(14)
3930   ink1_colr%    = Up_Para%(16)
3940   ink2_colr%    = Up_Para%(18)
3950   ink3_colr%    = Up_Para%(20)
3960   tab_stop%     = Up_Para%(22)
3970   right_margin% = Up_Para%(24)
3980   hi_pix%       = Up_Para%(26)
3990   wd_pix%       = Up_Para%(28)
4000   search_max%   = Up_Para%(30)
4010   str_max%      = Up_Para%(32)
4020   scr_mode%     = Up_Para%(34)
4030   insert_mode%  = Up_Para%(36)
4040   scr_pan%      = Up_Para%(38)
4050   block_type%   = Up_Para%(40)
4060   block_show%   = Up_Para%(42)
4070   cursor_delay% = Up_Para%(44)
4080   device$       = String_Para$(46)
4090   dflt_dvc$     = String_Para$(54)
4100   file_name$    = String_Para$(62)
4110   help_name$    = String_Para$(76)
4120   boot_name$    = String_Para$(90)
4130   word_delim$   = String_Para$(112)
4140   word_markers$ = String_Para$(144)
4150   END DEFine 
4160 :
4170 DEFine FuNction Up_Para%(off%)
4180  RETurn -PEEK_W(para_base+off%)-7096
4190  END DEFine 
4200 :
4210 DEFine PROCedure Dn_Para(off%,val%)
4220  POKE_W para_base+off%, -val%-7096
4230  END DEFine 
4240 :
4250 DEFine FuNction String_Para$(off%)
4260 LOCal lenf%
4270   lenf% = PEEK_W(para_base+off%)
4280   RETurn Stripped_Back$(PEEK$((para_base+off%+2),(lenf%)))
4290   END DEFine 
4300 :
4310 DEFine FuNction Stripped_Back$(str$)
4320 LOCal ii
4330   ii = LEN(str$) + 1
4340   REPeat back_lp
4350     ii = ii - 1 : IF ii < 1 : RETurn ""
4360     IF str$(ii) <> " " : RETurn str$(1 TO ii)
4370     END REPeat back_lp
4380   END DEFine 
4390 :
4400 DEFine FuNction Max_Short%(a%,b%)
4410   IF a% > b% : RETurn a% : ELSE : RETurn b%
4420   END DEFine 
4430 :
4440 DEFine FuNction Min_Short%(a%,b%)
4450   IF a% < b% : RETurn a% : ELSE : RETurn b%
4460   END DEFine 
4470 :
4480 DEFine PROCedure Load_Parameters
4490   Dn_Para 0, char_max%
4500   Dn_Para 2, scr_depth%
4510   Dn_Para 4, scr_width%
4520   Dn_Para 6, scr_vt_off%
4530   Dn_Para 8, scr_hz_off%
4540   Dn_Para 10, paper1_colr%
4550   Dn_Para 12, paper2_colr%
4560   Dn_Para 14, paper3_colr%
4570   Dn_Para 16, ink1_colr%
4580   Dn_Para 18, ink2_colr%
4590   Dn_Para 20, ink3_colr%
4600   Dn_Para 22, tab_stop%
4610   Dn_Para 24, right_margin%
4620   Dn_Para 26, hi_pix%
4630   Dn_Para 28, wd_pix%
4640   Dn_Para 30, search_max%
4650   Dn_Para 32, str_max%
4660   Dn_Para 34, scr_mode%
4670   Dn_Para 36, insert_mode%
4680   Dn_Para 38, scr_pan%
4690   Dn_Para 40, block_type%
4700   Dn_Para 42, block_show%
4710   Dn_Para 44, cursor_delay%
4720   Put_String  46,  6, (device$)
4730   Put_String  54,  6, (dflt_dvc$)
4740   Put_String  62, 12, (file_name$)
4750   Put_String  76, 12, (help_name$)
4760   Put_String  90, 20, (boot_name$)
4770   Put_String 112, 30, (word_delim$)
4780   Put_String 144, 30, (word_markers$)
4790   END DEFine 
4800 :
4810 DEFine PROCedure Put_String (off%, lenf%, str$)
4820 LOCal txt$(60)
4830   txt$ = str$ & FILL$(" ",lenf%-LEN(str$))
4840   POKE_W (para_base+off%), (lenf%)
4850   POKE$ (para_base+off%+2), (txt$)
4860   END DEFine 
4870 :
4880 DEFine PROCedure Re_Write_Program
4890 LOCal ii, t$(2), msga$(500), prog_base
4900   REPeat val_lp
4910     Show_Banner
4920     PRINT \\\\\"      Writing reconfigured program"
4930     wrong% = File_not_Available%(3,(dvc$ & prog_name$),0,0)
4940     IF wrong% <> 0 : Display_Error
4950     AT 17,0 : PAPER 0 : INK 4
4960     PRINT "Check/change volume; Press ENTER to continue, ESC to quit, other to restart"
4970     IF NOT wrong% : CLOSE #3
4980     ii = CODE(INKEY$(#1,-1))
4990     IF ii = ENTER% AND wrong% = 0
5000       wrong% = File_not_Available%(3,(dvc$ & prog_name$),1,0)
5010       IF wrong% = 0 : EXIT val_lp
5020       Display_Error : FOR ii=1 TO 1500 : END FOR ii : NEXT val_lp
5030       END IF 
5040     IF ii = ENTER% : NEXT val_lp
5050     wrong% = err_ntb%
5060     IF ii = ESC% : wrong% = err_cab%
5070     EXIT val_lp
5080     END REPeat val_lp
5090   IF wrong% <> 0 : RETurn 
5100   x = 0
5110   IF orig_char_max% <> data_max%
5120     IF orig_char_max% > 256 OR char_max% > 256
5130       x = (char_max% - 256) * 12 + (str_max% - 60) * 4
5140       IF x < 0 : x = 2
5150       END IF : END IF 
5160   IF x
5170     x = x + basic_data_space * 1024
5180     prog_base = ALLOCATION(file_len)
5190     IF prog_base < 1
5200       Save_on_Small_mc : ELSE : Save_on_Big_mc : END IF 
5210     ELSE 
5220     Patch_File : END IF 
5230   IF NOT x : AT 20,10 : PRINT "End of task" : CLS 2
5240   END DEFine 
5250 :
5260 DEFine PROCedure Patch_File
5270 LOCal x
5280   OPEN #3,(dvc$ & prog_name$)
5290   SET_POSITION #3,(data_point)
5300   x = bffr_addr - 1
5310   REPeat i_lp
5320     x = x + 1 : IF x > bffr_addr+length_of_paras : EXIT i_lp
5330     PRINT #3,CHR$(PEEK(x)); : END REPeat i_lp
5340   CLOSE #3
5350   END DEFine 
5360 :
5370 DEFine PROCedure Save_on_Small_mc
5380   Patch_File
5390   t$ = CHR$(10)
5400   COMMAND_LINE
5410   TYPE_IN (FILL$(" ",350)&t$)
5420   msga$ = "ink#0,0" &t$& "paper#0,0" &t$
5430   msga$ = msga$ & "window 448,210,32,6:at 20,10" & t$
5440   msga$ = msga$ & "for a=1 to 2500:endfor a" &t$
5450   msga$ = msga$ & "a=respr(" & file_len & ")" &t$
5460   msga$ = msga$ & "lbytes " & dvc$ & prog_name$ & ",a:"
5470   msga$ = msga$ & "delete " & dvc$ & prog_name$ &t$
5480   msga$ = msga$ & "SEXEC " & dvc$ & prog_name$ & ",a," & file_len &","&x&t$
5490   msga$ = msga$ & "print'End of task - reset system':cls#0:ink#0,7" & t$ & t$
5500   TYPE_IN (msga$)
5510   END DEFine 
5520 :
5530 DEFine PROCedure Save_on_Big_mc
5540   LBYTES (dvc$ & prog_name$), prog_base
5550   DELETE (dvc$ & prog_name$)
5560   MOVE_MEMORY bffr_addr TO prog_base+data_point, length_of_paras
5570   SEXEC  (dvc$ & prog_name$), prog_base, file_len, x
5580   x = 0
5590   END DEFine 
5600 :
5610 DEFine PROCedure Get_Colours (str$,papr%,inkk%)
5620 LOCal x$(4)
5630   PRINT " "\" ";: PAPER papr% : INK inkk% : CLS 3
5640   INPUT TO 20;(str$ & " paper: ");x$;
5650   papcol% = "0" & x$
5660   IF scr_mode% = 4 : papcol% = 2 * (papcol% DIV 2)
5670   IF LEN(x$) AND papcol% < 8 : ELSE : papcol% = papr%
5680   INPUT TO 45; "Ink: ";x$;
5690   inkcol% = "0" & x$
5700   IF scr_mode% = 4 : inkcol% = 2 * (inkcol% DIV 2)
5710   IF inkcol% <> papcol% AND LEN(x$) AND inkcol% < 8 : ELSE : inkcol% = inkk%
5720   END DEFine 
5730 :
5740 DEFine PROCedure Shutdown
5750   CURSOR_OFF
5760   END DEFine 
5770 :
5780 DEFine PROCedure Set_Screen_Format
5790   Draw_Border
5800   Reset_Main_Window
5810   END DEFine 
5820 :
5830 DEFine PROCedure Reset_Main_Window
5840   CURSOR_OFF
5850   WINDOW hz_pixels%,vt_pixels%,hz_off%,vt_off%
5860   PAPER 0 : INK 4
5870   END DEFine 
5880 :
5890 DEFine PROCedure Reset_Error_Window
5900   CURSOR_OFF : WINDOW hz_pixels%,chi_pix%,hz_off%,vt_off%+chi_pix%*(depth%-1)
5910   PAPER 2 : INK 0
5920   END DEFine 
5930 :
5940 DEFine PROCedure Clear_Error
5950   Reset_Error_Window : PAPER 0 : CLS 4
5960   wrong% = FALSE% : Reset_Main_Window
5970   END DEFine 
5980 :
5990 DEFine PROCedure Reset_Command_Window
6000 LOCal x%
6010   CURSOR_OFF
6020   WINDOW hz_pixels%, chi_pix%*txt_lines%, hz_off%, vt_off%+chi_pix%*lin%
6030   PAPER 0 : INK 4 : CLS
6040   PRINT msg$;
6050   x% = LEN(msg$) MOD width%
6060   WINDOW txt_width%*cwd_pix%, chi_pix%*txt_lines%, hz_off%+cwd_pix%*x%, vt_off%+chi_pix%*lin%
6070   INK 7 : PRINT ip_str$;
6080   END DEFine 
6090 :
6100 DEFine FuNction Key_from_Keybd
6110 LOCal x$(2)
6120   IF LEN(key_bffr$)
6130     x$ = key_bffr$(array_base%)
6140     IF LEN(key_bffr$) > array_base%
6150       key_bffr$ = key_bffr$(array_base%+1 TO LEN(key_bffr$)) : ELSE 
6160       key_bffr$ = "" : END IF 
6170     ELSE 
6180     x$ = INKEY$(#1,-1)
6190     END IF 
6200   IF CODE(x$) = SPACE_shift% : x$ = " "
6210   RETurn CODE(x$)
6220   END DEFine 
6230 :
6240 DEFine PROCedure Adjust_Screen
6250 LOCal x%
6260   scr_depth% = scr_depth% + 1
6270   Draw_Box : x% = (scr_width% - 28) / 2 : IF x% < 1 : x% = 0
6280   PAPER paper2_colr% : INK ink2_colr% : CLS
6290   PRINT \\\\TO x%;"Use  to reposition screen"
6300   PRINT TO x%;"Use ALT  to resize screen"
6310   PRINT TO x%;" Use ENTER to accept screen"
6320   AT 0,0
6330   REPeat chg_scrn
6340     key = Key_from_Keybd
6350     IF key = ENTER% : key_bffr$ = "" : Draw_Box : EXIT chg_scrn
6360     IF key < 128   : NEXT chg_scrn
6370     SELect ON key
6380       = lf_arrow% : IF scr_hz_off% >= 5 : scr_hz_off% = scr_hz_off% - 3 : Draw_Box
6390       = rt_arrow% : IF scr_hz_off% + scr_width%*wd_pix% <= max_wide%-wd_pix% : scr_hz_off% = scr_hz_off%+wd_pix% : Draw_Box
6400       = up_arrow% : IF scr_vt_off% >= 6 : scr_vt_off% = scr_vt_off% - 5 : Draw_Box
6410       = dn_arrow% : IF scr_vt_off% + scr_depth%*hi_pix% <= max_deep%-hi_pix% : scr_vt_off% = scr_vt_off%+hi_pix% : Draw_Box
6420       = lf_alt%   : IF scr_width% > min_width% : scr_width% = scr_width% - 1 : Draw_Box
6430       = rt_alt%   : IF scr_hz_off% + scr_width%*wd_pix% <= max_wide%-wd_pix% : scr_width% = scr_width%+1 : Draw_Box
6440       = scroll_up%: IF scr_depth% > min_depth% : scr_depth% = scr_depth% - 1 : Draw_Box
6450       = scroll_dn%: IF scr_vt_off% + scr_depth%*hi_pix% <= max_deep%-hi_pix% : scr_depth% = scr_depth%+1 : Draw_Box
6460       END SELect 
6470     END REPeat chg_scrn
6480   scr_depth%  = scr_depth% - 1
6490   REMark scr_vt_adj% = scr_depth% - 1
6500   REMark scr_hz_adj% = (scr_width% * 3) DIV 4
6510   END DEFine 
6520 :
6530 DEFine PROCedure Draw_Box
6540   scr_hz_pixels% = wd_pix% * scr_width% : scr_vt_pixels% = hi_pix% * (scr_depth%-1)
6550   Draw_Border
6560   END DEFine 
6570 :
6580 DEFine PROCedure Draw_Border
6590   PAPER 0 : BORDER 0 : CLS : PAPER paper2_colr% : INK ink2_colr%
6600   WINDOW scr_hz_pixels%+4,scr_vt_pixels%+12,scr_hz_off%-2,scr_vt_off%-1
6610   BORDER 1, (ABS(7-paper2_colr%))  : CLS
6620   PRINT \\\"    Left: ";scr_hz_off%,"     Top: ";scr_vt_off%\"   Width: ";scr_width%,"  Height: ";scr_depth%
6630   END DEFine 
6640 :
6650 DEFine PROCedure Announce
6660   MODE 0 : WINDOW 512,256,0,0 : PAPER 0 : CLS
6670   PAPER 2 : INK 0
6680   WINDOW 176,120,160,75 : CLS : PRINT
6690   CSIZE 3,1 :PRINT "  EDITOR"
6700   CSIZE 0,0 :PRINT \"    Screen text editor"
6710   PRINT "       Configurator"\"       version ";vers$
6720   PRINT "    Chas Dillon  1986"\\\" Press any key to continue ";
6730   CURSOR_ON : key_bffr$ = "" : key = Key_from_Keybd
6740   END DEFine 
6750 :
6760 DEFine PROCedure Display_Error
6770 LOCal err_txt$(30), ii
6780   ii = wrong%
6790   SELect ON ii
6800     = err_syn% : err_txt$ = "Syntax error"
6810     = err_cab% : err_txt$ = "Command abandoned"
6820     = err_nex% : err_txt$ = "Number expected"
6830     = err_tex% : err_txt$ = "Text expected"
6840     = err_ltl% : err_txt$ = "Line too long"
6850     = err_fnf% : err_txt$ = "File not found"
6860     = err_cof% : err_txt$ = "Can't open file"
6870     = err_oom% : err_txt$ = "Out of memory"
6880     = err_ntb% : err_txt$ = "Number too big"
6890     = err_nts% : err_txt$ = "Number too small"
6900     = err_msp% : err_txt$ = "Make space on device"
6910     = err_bfn% : err_txt$ = "Bad file name"
6920     = err_nef% : err_txt$ = "Not EDITOR file"
6930     = err_oor% : err_txt$ = "Out of range"
6940     END SELect 
6950   Reset_Error_Window
6960   PRINT TO 20;err_txt$; : CLS 4
6970   Reset_Main_Window : AT lin%,col%
6980   key_bffr$ = ""
6990   REPeat drain : IF NOT LEN(INKEY$(#1,0)) : EXIT drain
7000   END DEFine 
7010 :
7020 DEFine FuNction Input_Length(chn%)
7030 LOCal x
7040   SET_POSITION #(chn%), 999999 : x = POSITION(#(chn%))
7050   SET_POSITION #(chn%), 0 : RETurn x
7060   END DEFine 
7070 :
7080 DEFine PROCedure Calc_Text_Limits
7090   txt_width% = width% - (LEN(msg$) MOD width%)
7100   txt_max_ch% = txt_width% * depth% - 2
7110   IF txt_max_ch% > max_ch% : txt_max_ch% = max_ch%
7120   IF LEN(ip_str$) > txt_max_ch% : ip_str$ = ip_str$(1 TO txt_max_ch%)
7130   txt_lines% = 1 + (LEN(ip_str$) DIV txt_width%)
7140   Reset_Command_Window
7150   END DEFine 
7160 :
7170 DEFine FuNction Text_Response$(str$,msg$)
7180 LOCal x$(2), ii, ptr%
7190   ip_str$ = str$
7200   Calc_Text_Limits
7210   txt_lin% = 0 : txt_ptr% = 0 : ptr% = 0
7220   AT txt_lin%, ptr% : CURSOR_ON #1!
7230   REPeat ip_edit_lp
7240     ii = Key_from_Keybd : x$ = CHR$(ii)
7250     SELect ON ii
7260       = up_arrow%, lf_alt% : ptr% = 0 : Posn_Txt_Cursor
7270       = dn_arrow%, rt_alt% : ptr% = LEN(ip_str$) : Posn_Txt_Cursor
7280       = lf_arrow%  : IF ptr%>0
7290                        ptr% = ptr%-1 : Posn_Txt_Cursor : END IF 
7300       = rt_arrow%  : IF ptr% < LEN(ip_str$)
7310                        ptr% = ptr%+1 : Posn_Txt_Cursor : END IF 
7320       = ENTER%     : EXIT ip_edit_lp
7330       = del_lf%    : Delete_Char (TRUE%)
7340       = del_rt%    : Delete_Char (FALSE%)
7350       = del_stol%  : IF ptr%
7360                        IF ptr%<LEN(ip_str$)
7370                          ip_str$ = ip_str$(ptr%+1 TO LEN(ip_str$)): ptr%=0
7380                          ELSE : ip_str$ = "": ptr% = 0 : END IF 
7390                        Show_Resp : END IF 
7400       = del_ndol%  : IF ptr%<LEN(ip_str$)
7410                        IF ptr%
7420                          ip_str$ = ip_str$(array_base% TO ptr%) : ptr% = LEN(ip_str$)
7430                          ELSE : ip_str$ = "": ptr% = 0 :END IF 
7440                        Show_Resp : END IF 
7450       = REMAINDER : Add_Char (FALSE%)
7460       END SELect 
7470     END REPeat ip_edit_lp
7480   Reset_Main_Window
7490   RETurn ip_str$
7500   END DEFine 
7510 :
7520 DEFine PROCedure Add_Char(check_it)
7530   IF ptr% = 0 AND check_it : RETurn 
7540   IF LEN(ip_str$) >= txt_max_ch% : RETurn 
7550   IF ptr% = LEN(ip_str$)
7560     ip_str$ = ip_str$ & x$ : ELSE 
7570     IF ptr% = 0
7580       ip_str$ = x$ & ip_str$ : ELSE 
7590       ip_str$ = ip_str$(array_base% TO ptr%) & x$ & ip_str$(ptr%+1 TO LEN(ip_str$))
7600       END IF : END IF 
7610   ptr% = ptr%+1
7620   Show_Resp
7630   END DEFine 
7640 :
7650 DEFine PROCedure Delete_Char(char_on_left)
7660 LOCal a$(txt_max_ch%)
7670   IF LEN(ip_str$) = 0 : RETurn 
7680   IF char_on_left
7690     IF ptr% = 0   : RETurn 
7700     IF LEN(ip_str$) = array_base%
7710       ip_str$ = "" : ELSE 
7720       IF ptr% = LEN(ip_str$)
7730         ip_str$  = ip_str$(array_base% TO LEN(ip_str$)-1) : ELSE 
7740         IF ptr%-1 : a$ = ip_str$(array_base% TO ptr%-1) : ELSE : a$=""
7750         ip_str$ = a$ & ip_str$(ptr%+1 TO LEN(ip_str$))
7760         END IF : END IF 
7770     ptr% = ptr% -1
7780     ELSE 
7790     IF ptr%=LEN(ip_str$) : RETurn 
7800     IF LEN(ip_str$) = array_base%
7810       ip_str$ = "" : ELSE 
7820       IF ptr% = 0
7830         ip_str$ = ip_str$(array_base% + 1 TO LEN(ip_str$)) : ELSE 
7840         IF ptr%+1=LEN(ip_str$) : a$="" : ELSE : a$ = ip_str$(ptr%+2 TO LEN(ip_str$))
7850         ip_str$ = ip_str$(array_base% TO ptr%) & a$
7860         END IF : END IF 
7870     END IF 
7880   Show_Resp
7890   END DEFine 
7900 :
7910 DEFine PROCedure Show_Resp
7920 LOCal tmp%
7930   CURSOR_OFF
7940   tmp% = LEN(ip_str$) DIV txt_width%  + 1
7950   IF tmp% > txt_lines%
7960     txt_lines% = tmp%
7970     Reset_Command_Window
7980     ELSE 
7990     REPeat clr_below
8000       IF tmp% = txt_lines% : EXIT clr_below
8010       AT tmp%, 0 : CLS 4 : tmp% = tmp% + 1
8020       END REPeat clr_below
8030     AT 0,0 : PRINT ip_str$; : CLS 4 : CLS 2
8040     END IF 
8050   Posn_Txt_Cursor
8060   END DEFine 
8070 :
8080 DEFine PROCedure Posn_Txt_Cursor
8090 LOCal txt_lin%, txt_ptr%
8100   txt_lin% = ptr% DIV txt_width%
8110   txt_ptr% = ptr% MOD txt_width%
8120   AT txt_lin%, txt_ptr% : CURSOR_ON #1!
8130   END DEFine 
8140 :
8150 DEFine FuNction File_not_Available% (chn%, str$, for_output, space_needed)
8160 LOCal x, free_capacity
8170   IF LEN(str$) = 0 OR LEN(str$) > 36 : RETurn err_bfn%
8180   IF NOT for_output
8190     IF "neto" INSTR str$ = 1 : RETurn err_bfn%
8200     ELSE 
8210     IF "neti" INSTR str$ = 1 : RETurn err_bfn%
8220     END IF 
8230   directory_device% = TRUE%
8240   IF for_output : x = 2 : ELSE : x = 1
8250   x = DEVICE_STATUS((x), (str$))
8260   IF x = 65535 * 512 : directory_device% = FALSE%
8270   IF NOT for_output
8280     IF x >= 0
8290       OPEN_IN #(chn%), (str$) : RETurn FALSE%
8300       ELSE : RETurn err_fnf% : END IF 
8310     END IF 
8320   IF x = -8
8330     IF DEVICE_STATUS(2,str$&CHR$(0))<0 : RETurn err_cof%
8340     yn$ = Text_Response$("","Overwrite "&str$&" (y/n): ")
8350     IF wrong% OR yn$ == "n" : RETurn err_cab%
8360     free_capacity = DEVICE_STATUS(0,(str$))
8370     OPEN_IN #chn%, str$
8380     free_capacity = free_capacity + Input_Length((chn%))
8390     CLOSE #chn%
8400     ELSE 
8410     IF x < 0 : RETurn err_cof%
8420     free_capacity = x
8430     END IF 
8440   IF free_capacity < space_needed : RETurn err_msp%
8450   REMark IF x = -8 : DELETE (str$)
8460   REMark OPEN_NEW #(chn%), (str$)
8470   RETurn FALSE%
8480   END DEFine 
